import 'package:flutter/material.dart';
import 'package:microfrontends/microfrontends.dart';

import 'app_widget.dart';
import 'main.dart';

class Header extends StatelessWidget {
  final AppWidget widget;
  const Header({Key? key, required this.widget}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      color: Theme.of(context).canvasColor,
      child: Row(
        children: [
          if (widget is! ExamplesGrid)
            TextButton.icon(
              onPressed: () {
                context.setState<AppWidget>(ExamplesGrid());
              },
              icon: Icon(Icons.chevron_left),
              label: Padding(
                padding: const EdgeInsets.only(right: 8.0),
                child: Text('Back'),
              ),
            ),
          Expanded(
            child: Padding(
              padding: const EdgeInsets.all(8.0),
              child: Text(
                widget.title,
                textAlign: TextAlign.center,
                style: TextStyle(fontWeight: FontWeight.bold),
              ),
            ),
          ),
        ],
      ),
    );
  }
}
