import 'dart:math';

import 'package:flutter/material.dart';

import 'config.dart';

final r = Random();

mixin ColorGridApp {
  int get length => rowsCount * colsCount;
  int get colorsPerIteration => 50;
  late List<Color> colors = generate();
  late Set<int> nonColored = Set.from(List.generate(length, (index) => index));

  List<Color> generate() {
    final length = rowsCount * colsCount;
    nonColored = Set.from(List.generate(length, (index) => index));
    return List.generate(rowsCount * colsCount, (index) => Color(0xffeaeaea));
  }

  getNextColor() {
    int i = r.nextInt(nonColored.length);
    int j = nonColored.elementAt(i);

    nonColored.remove(j);

    colors[j] = Color.fromARGB(255, 70, 120 * j ~/ length, 120);
  }
}
