import 'package:flutter/material.dart';
import 'package:microfrontends/microfrontends.dart';
import 'package:example/perf_showcase/config.dart';
import 'package:example/perf_showcase/implementations/microfrontends/state_container.dart';
import 'package:example/perf_showcase/widgets/tile.dart';

import 'state.dart';

class MicrofrontendsExample extends StatelessWidget {
  const MicrofrontendsExample({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return StaticContainer(
      container: ColorGridStateContainer(),
      child: Builder(
        builder: (context) => Scaffold(
          floatingActionButton: FloatingActionButton(
            child: Icon(Icons.brush),
            onPressed: () {
              context.mutation(GenerateColors());
            },
          ),
          body: Column(
            children: [
              for (int i = 0; i < rowsCount; i++)
                Expanded(
                  child: Row(
                    children: [
                      for (int j = 0; j < colsCount; j++)
                        Expanded(
                          child: context.subscribe<Color>(
                            params: i * colsCount + j,
                            builder: (context, value, child) {
                              return Tile(color: value);
                            },
                          ),
                        ),
                    ],
                  ),
                )
            ],
          ),
        ),
      ),
    );
  }
}
