import 'package:flutter/widgets.dart';
import 'package:microfrontends/microfrontends.dart';
import 'package:example/perf_showcase/config.dart';

import 'state.dart';

class ColorGridStateContainer extends StateContainer<ColorGridState> {
  final initialState = ColorGridState()..generate();

  @override
  queries(_) {
    query<Color>((ctrl, state, params) => state.colors[params as int]);
    return super.queries(_);
  }

  @override
  mutations(_) {
    mutation<GenerateColors>((ctrl, state, mutation) {
      ctrl.run(() async* {
        while (true) {
          await Future.delayed(pause);
          for (int i = 0; i < state.colorsPerIteration; i++) {
            try {
              state.getNextColor();
            } catch (err) {
              break;
            }
          }
          yield ColorGridState()
            ..colors = state.colors
            ..nonColored = state.nonColored;
          if (state.nonColored.length == 0) break;
        }
      });

      return state;
    });

    return super.mutations(_);
  }
}
