import 'package:flutter/material.dart';
import 'package:example/perf_showcase/color_grid.dart';
import 'package:example/perf_showcase/config.dart';
import 'package:example/perf_showcase/widgets/tile.dart';

class SetStateExample extends StatefulWidget {
  const SetStateExample({Key? key}) : super(key: key);

  @override
  _SetStateExampleState createState() => _SetStateExampleState();
}

class _SetStateExampleState extends State<SetStateExample> with ColorGridApp {
  @override
  void didUpdateWidget(covariant SetStateExample oldWidget) {
    colors = generate();
    super.didUpdateWidget(oldWidget);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      floatingActionButton: FloatingActionButton(
        child: Icon(Icons.brush),
        onPressed: () async {
          for (int i = 0; i < colors.length; i++) {
            await Future.delayed(pause);
            if (!mounted) {
              break;
            }

            setState(() {
              for (int i = 0; i < colorsPerIteration; i++) {
                try {
                  getNextColor();
                } catch (err) {
                  break;
                }
              }
            });
          }
        },
      ),
      body: Column(
        children: [
          for (int i = 0; i < rowsCount; i++)
            Expanded(
              child: Row(
                children: [
                  for (int j = 0; j < colsCount; j++)
                    Expanded(
                      child: Tile(color: colors[i * colsCount + j]),
                    ),
                ],
              ),
            )
        ],
      ),
    );
  }
}
