import 'package:flutter/material.dart';
import 'package:microfrontends/microfrontends.dart';

import 'state.dart';

class Link extends StatelessWidget {
  const Link({Key? key, required this.page}) : super(key: key);

  final String page;

  @override
  Widget build(BuildContext context) {
    final child = Text(
      page,
      textAlign: TextAlign.center,
    );

    return InkWell(
      onTap: () {
        context.mutation(SetActivePage(page));
      },
      child: context.subscribe<ActivePage>(
        child: child,
        builder: (context, value, child) {
          return AnimatedContainer(
            duration: const Duration(milliseconds: 200),
            padding: const EdgeInsets.all(20.0),
            color: value.payload == page ? Colors.white : Color(0xffeaeaea),
            child: child,
          );
        },
      ),
    );
  }
}
