import 'package:microfrontends/microfrontends.dart';

import 'state.dart';

class NavContainer extends StateContainer<NavState> {
  final String initialPage;
  final List<String> pages;

  final NavState initialState;

  NavContainer(this.initialPage, this.pages)
      : initialState = NavState(initialPage, pages);

  @override
  queries(_) {
    query<ActivePage>((ctrl, state, params) => ActivePage(state.activePage));
    query<List<String>>((ctrl, state, params) => state.pages);

    return super.queries(_);
  }

  @override
  mutations(_) {
    mutation<SetActivePage>(
      (ctrl, state, mutation) => NavState(mutation!.payload, state.pages),
    );
    return super.mutations(_);
  }
}
