import 'package:flutter/material.dart';
import 'package:microfrontends/microfrontends.dart';

import 'package:example/perf_showcase/config.dart';
import 'package:example/perf_showcase/nav/link.dart';
import 'package:example/perf_showcase/nav/state.dart';

import 'package:example/perf_showcase/implementations/set_state/set_state_example.dart';
import 'package:example/perf_showcase/implementations/microfrontends/microfrontends_example.dart';

class Home extends StatelessWidget {
  const Home({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    colsCount = 140;
    rowsCount = 60;

    assert(() {
      colsCount = 70;
      rowsCount = 30;
      return true;
    }());

    final pages = context
        .query<List<String>>()!
        .map((e) => Expanded(child: Link(page: e)))
        .toList();

    return Column(
      children: [
        Row(children: pages),
        Expanded(
          child: context.subscribe<ActivePage>(
            builder: (context, value, child) {
              switch (value.payload) {
                case 'setState':
                  return SetStateExample();
                case 'microfrontends':
                  return MicrofrontendsExample();
                default:
                  return Center(
                    child: Text('Unknown page ${value.payload}'),
                  );
              }
            },
          ),
        )
      ],
    );
  }
}
