import 'dart:collection';

class Context<T, K> {
  Context? parent;

  final HashMap<T, K> _storage;

  Context([Map<T, K>? initial]) : _storage = HashMap<T, K>.from(initial ?? {});

  inherit(Context<T, K> other) {
    parent = other;
    _storage.addAll(other._storage);
  }

  addAll(Context<T, K> other) {
    _storage.addAll(other._storage);
  }

  K? operator [](T key) {
    return _storage[key];
  }

  operator []=(T key, K value) {
    _storage[key] = value;
  }

  remove(T key) {
    _storage.remove(key);
  }

  clear() {
    parent = null;
    _storage.clear();
  }
}
