import 'package:flutter/widgets.dart';

import 'boxed.dart';
import 'mutation.dart';
import 'state_container.dart';

class TextQuery<T> extends Boxed<String> {
  TextQuery(String payload) : super(payload);
}

class ClearTextQuery<T> extends Mutation<Null> {
  ClearTextQuery() : super(null);
}

class TextEditingControllerStateContainer<T> extends StateContainer<String> {
  final TextEditingController controller;
  String get initialState => controller.text;

  TextEditingControllerStateContainer(this.controller);

  @override
  Stream<String> init(_) async* {
    controller.addListener(onChange);
  }

  onChange() {
    state = controller.text;
  }

  @override
  queries(_) {
    query<TextQuery<T>>((ctrl, state, params) => TextQuery<T>(state));
    return super.queries(_);
  }

  @override
  mutations(_) {
    mutation<ClearTextQuery<T>>((ctrl, state, params) => '');
    return super.mutations(_);
  }
}
