import 'package:microfrontends/microfrontends.dart';

import 'mock_state.dart';

class CountdownContainer extends StateContainer<MockState> {
  final int count;
  final Duration duration;

  CountdownContainer(this.count, this.duration);

  @override
  MockState get initialState => MockState(0);

  @override
  Stream<MockState> init(StateContainerContext context) async* {
    for (int i = 0; i < count; i++) {
      yield MockState(i);
      await Future.delayed(duration);
    }
  }
}
