import 'package:microfrontends/microfrontends.dart';

import 'mock_state.dart';

class Increment extends Mutation<Null> {
  Increment() : super(null);
}

class CountN extends Mutation<int> {
  CountN(int payload) : super(payload);
}

class MockContainer extends StateContainer<MockState> {
  static MockContainer? _instance;

  factory MockContainer() => _instance ??= MockContainer._();

  MockContainer._();

  @override
  MockState get initialState => MockState(0);

  @override
  queries(StateContainerContext context) {
    query((ctrl, value, arg) => value.value);
    return super.queries(context);
  }

  @override
  mutations(StateContainerContext context) {
    mutation<Increment>((ctrl, value, arg) => MockState(value.value + 1));
    return super.mutations(context);
  }
}
