import 'package:flutter/material.dart';
import 'package:microfrontends/microfrontends.dart';
import 'package:microfrontends/src/state_container_provider.dart';

import 'mock_state.dart';

class StateContainerProviderApp extends StatelessWidget {
  final StateContainer<MockState> container;
  final WidgetBuilder builder;
  const StateContainerProviderApp({
    Key? key,
    required this.builder,
    required this.container,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        body: StateContainerProvider(
          container: container..state = MockState(0),
          child: Builder(builder: builder),
        ),
      ),
    );
  }
}
