import 'package:flutter/widgets.dart';

class TestApp extends StatelessWidget {
  static final _valueNotifier = ValueNotifier(0);

  static rebuild() {
    _valueNotifier.value++;
  }

  final WidgetBuilder builder;

  const TestApp({Key? key, required this.builder}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ValueListenableBuilder(
      valueListenable: _valueNotifier,
      builder: (context, _, __) {
        return builder(context);
      },
    );
  }
}
