import 'package:flutter/widgets.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:microfrontends/microfrontends.dart';

import 'mock/mock_container.dart';
import 'mock/mock_state.dart';
import 'mock/test_app.dart';

final groupTitle = 'StaticContainer';

void main() {
  testWidgets('always provides a container passed during first build',
      (tester) async {
    int? hashCode;

    await tester.pumpWidget(
      TestApp(
        builder: (context) {
          return StaticContainer(
            container: MockContainer(),
            builder: (context) {
              final currentContainerHashCode =
                  StateContainer.of<MockState>(context).hashCode;
              if (hashCode != null) {
                expect(hashCode, equals(currentContainerHashCode));
              }

              hashCode = currentContainerHashCode;
              return SizedBox();
            },
          );
        },
      ),
    );

    TestApp.rebuild();
    await tester.pump();

    TestApp.rebuild();
    await tester.pump();
  });
}
